package com.mmvce.controller;

import com.cycling74.max.Atom;
import com.mmvce.events.*;
import java.util.*;
import com.mmvce.global.*;
public class TheBigController {

	
		public void doSomeEvent(MSEvent evt){
			evt.post("bigcontrol.dosomeevent");
			switch(evt.getObjectType()){
			case MSEvent.MODULE:
				evt =moduleCommand(evt);
				break;
			case MSEvent.CONNECTION:
				evt = connectionCommand(evt);
				break;
			}
			
			if(evt!=null){
				fireMSEvent(evt);
			}
		}
	
		
		private MSEvent moduleCommand(MSEvent evt){
			
			String name;
			switch(evt.getCommand())
			{
			case MSEvent.ADD:
			
				
				name = evt.getArguments().get(0).getString();
				if(God.getSoup().hasAModuleNamed(name))
				{
					return null;
				}
				
				God.getSoup().addModule(name);
				break;
				
				
				
			case MSEvent.DELETE:
				name = evt.getArguments().get(0).getString();
				God.getSoup().deleteModule(name);
				break;
				
				
				
			}
			
			return evt;
		}

	private MSEvent connectionCommand(MSEvent evt) {

		String from;
		String to;
		switch (evt.getCommand()) {
		
		
		
		case MSEvent.ADD:
			from = evt.getArguments().get(0).getString();
			to = evt.getArguments().get(1).getString();
			
			
			
			God.getSoup().addConnection(from, to);
			break;
			
			
			
		case MSEvent.DELETE:
			from = evt.getArguments().get(0).getString();
			to = evt.getArguments().get(1).getString();
			God.getSoup().removeConnection(from, to);
			break;
			
			
		}

		return evt;
	}
	
	
	
	
	
	
	
	
	
	
	
		// Create the listener list
		protected javax.swing.event.EventListenerList listenerList = new javax.swing.event.EventListenerList();

		// This methods allows classes to register for MSEvents
		public void addMSEventListener(MSEventListener listener) {
			listenerList.add(MSEventListener.class, listener);
		}

		// This methods allows classes to unregister for MSEvents
		public void removeMSEventListener(MSEventListener listener) {
			listenerList.remove(MSEventListener.class, listener);
		}

		// This private class is used to fire MSEvents
		void fireMSEvent(MSEvent evt) {
			Object[] listeners = listenerList.getListenerList();
			// Each listener occupies two elements - the first is the listener
			// class
			// and the second is the listener instance
			for (int i = 0; i < listeners.length; i += 2) {
				if (listeners[i] == MSEventListener.class) {
					((MSEventListener) listeners[i + 1]).MSEventOccurred(evt);
				}
			}
		}
	

}
