package com.mmvce.events;
import java.util.*;
//Declare the event. It must extend EventObject.
import com.cycling74.max.*;

public class MSEvent extends EventObject {
    public MSEvent(Object source) {
        super(source);
    }
    
    public static final int MODULE=0,CONNECTION=1,
    ADD=0,DELETE=1;
    
    int command = 0;
    int objectType = 0;
    ArrayList<Atom> arguments;
    
    
    public MSEvent( int objectType, int command)
    {
    	this(command,objectType,new Object());
    }
   
    
	public MSEvent( int command, int objectType,Object arg0) {
		super(arg0);
		this.command = command;
		this.objectType = objectType;
	}
	
	
	public int getCommand() {
		return command;
	}
	public void setCommand(int command) {
		this.command = command;
	}
	public int getObjectType() {
		return objectType;
	}
	public void setObjectType(int objectType) {
		this.objectType = objectType;
	}


	public ArrayList<Atom> getArguments() {
		return arguments;
	}


	public void setArguments(ArrayList<Atom> arguments) {
		this.arguments = arguments;
	}
	
	
	public void post(String label)
	{
		MaxObject.post("Event "+label+"  cmd:"+command+"  objectType:"+objectType);
	}
    
    
}
