package com.mmvce.model;
import java.util.*;
public class ModuleSoup {

	Hashtable<String, Module> modules;
	ArrayList<Connection> connections;
	

	public ModuleSoup(){
		modules = new Hashtable<String, Module>();
		connections= new ArrayList<Connection>();
	}
	
	public void addConnection(String from,String to)
	{
		if(modules.containsKey(from)&&modules.containsKey(to)){
			connections.add(new Connection(from,to));
		}
		
	}
	
	public void addModule(String name)
	{
		modules.put(name, new Module(name));
	}
	
	public void deleteModule(String name)
	{
		modules.remove(name);
		
		Iterator<Connection> conIt = connections.iterator();
		while(conIt.hasNext())
		{
			Connection loopCon = conIt.next();
			if(loopCon.getInTo().equals(name)||loopCon.getOutFrom().equals(name))
			{
				conIt.remove();
			}
		}
	}
	
	public void removeConnection(String from, String to){
		Iterator<Connection> conIt = connections.iterator();
		while(conIt.hasNext())
		{
			Connection loopCon = conIt.next();
			if(loopCon.getInTo().equals(from)&&loopCon.getOutFrom().equals(to))
			{
				conIt.remove();
			}
		}

	}
	public boolean hasAModuleNamed(String name)
	{
		return modules.containsKey(name);
	}
	
}
