package com.mmvce.events;

import java.util.*;
import com.cycling74.max.*;

public class MSEFactory {

	public static MSEvent deleteConnection(String from, String to) {

		MSEvent returnMe = new MSEvent(MSEvent.CONNECTION, MSEvent.DELETE);
		ArrayList<Atom> args = new ArrayList<Atom>();
		args.add(Atom.newAtom(from));
		args.add(Atom.newAtom(to));
		returnMe.setArguments(args);
		return returnMe;

	}

	public static MSEvent createConnection(String from, String to) {

		MSEvent returnMe = new MSEvent(MSEvent.CONNECTION, MSEvent.ADD);
		ArrayList<Atom> args = new ArrayList<Atom>();
		args.add(Atom.newAtom(from));
		args.add(Atom.newAtom(to));
		returnMe.setArguments(args);
		return returnMe;

	}

	public static MSEvent deleteModule(String name) {

		MSEvent returnMe = new MSEvent(MSEvent.MODULE, MSEvent.DELETE);
		ArrayList<Atom> args = new ArrayList<Atom>();
		args.add(Atom.newAtom(name));
		returnMe.setArguments(args);
		return returnMe;

	}

	public static MSEvent addModule(String name) {

		MSEvent returnMe = new MSEvent(MSEvent.MODULE, MSEvent.ADD);
		ArrayList<Atom> args = new ArrayList<Atom>();
		args.add(Atom.newAtom(name));
		returnMe.setArguments(args);
		return returnMe;

	}

}
