package com.mmvce.view;

import com.cycling74.max.*;
import com.mmvce.global.God;
import com.mmvce.events.*;

public class UserInteraction extends MaxObject implements MSEventListener {

	
	
	/* send events!*/
	
	
	public UserInteraction()
	{
		God.getCtl().addMSEventListener(this);
	}
	
	public void addModule(String n) {

		God.getCtl().doSomeEvent(MSEFactory.addModule(n));

	}

	public void deleteModule(String n) {

		God.getCtl().doSomeEvent(MSEFactory.deleteModule(n));

	}

	public void addConnection(String from, String to) {

		God.getCtl().doSomeEvent(MSEFactory.createConnection(from, to));

	}

	public void deleteConnection(String from, String to) {
		God.getCtl().doSomeEvent(MSEFactory.deleteConnection(from, to));
	}

	
	/*END SEND EVENTS*/
	
	
	
	
	
	
	/* INTERPRET EVENTS! */

	public void MSEventOccurred(MSEvent evt) {

		
		MaxObject.post("ViewA.MSEventOccurred");
		switch (evt.getObjectType()) {
		case MSEvent.MODULE:
			moduleCommand(evt);
			break;
		case MSEvent.CONNECTION:
			connectionCommand(evt);
			break;
		}

	}

	private MSEvent moduleCommand(MSEvent evt) {

		MaxObject.post("ViewA.module event occurred");
		String name;
		switch (evt.getCommand()) {
		case MSEvent.ADD:
			name = evt.getArguments().get(0).getString();
			outAddModule(name);
			
			MaxObject.post("ViewA.addmodule event occurred");
			break;

		case MSEvent.DELETE:
			name = evt.getArguments().get(0).getString();
			outDeleteModule(name);
			break;

		}

		return evt;
	}

	private MSEvent connectionCommand(MSEvent evt) {

		
		
		String from;
		String to;
		
		
		switch (evt.getCommand()) {

		case MSEvent.ADD:
			from = evt.getArguments().get(0).getString();
			to = evt.getArguments().get(1).getString();
			outAddConnection(from,to);
			
			
			break;

		case MSEvent.DELETE:
			from = evt.getArguments().get(0).getString();
			to = evt.getArguments().get(1).getString();
			
			outDeleteConnection(from,to);
			
			break;

		}

		return evt;
	}

	
	public void outAddConnection(String from,String to){
		
	}
	
	public void outDeleteConnection(String from,String to){
		
	}
	
	
	public void outAddModule(String name){
		
	}
	
	public void outDeleteModule(String name){
		
	}
	
}
